#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){

	ofBackground(250,250,250);
	
	ofSetFrameRate(60);
	ofSetWindowShape(1024, 768);
	
	nCurveVertexes = 75;
	
	for(int i=0; i<75; i++) {
		curveVertices[i].x=40+i*10;
			curveVertices[i].y=40;
		//curveVertices[i].set(i*10,40);
	
}

	
	for (int i = 0; i < nCurveVertexes; i++){
		curveVertices[i].bOver 			= false;
		curveVertices[i].bBeingDragged 	= false;
		curveVertices[i].radius = 4;
	}
	
	
	
	for (int i=0; i<75; i++) {
		dotNum[i].x= ofRandom(100, 900);
		dotNum[i].y= ofRandom(100,600);
	}
	
	
}

//--------------------------------------------------------------
void testApp::update(){

//	ofBackground(75+pt.x/4, 50+pt.y/3, 150);
	
	ofBackground(70, 80+pt.y/3, 80+pt.x/4);
	
	
}

//--------------------------------------------------------------
void testApp::draw(){
	
	

	ofSetColor(0x2bdbe6);
	ofNoFill();
	ofBeginShape();
	
	for (int i = 0; i < nCurveVertexes; i++){
		if (i == 0){
			ofCurveVertex(curveVertices[0].x, curveVertices[0].y); // we need to duplicate 0 for the curve to start at point 0
			ofCurveVertex(curveVertices[0].x, curveVertices[0].y); // we need to duplicate 0 for the curve to start at point 0
		} else if (i == nCurveVertexes-1){
			ofCurveVertex(curveVertices[i].x, curveVertices[i].y);
			ofCurveVertex(curveVertices[0].x, curveVertices[0].y);	// to draw a curve from pt 6 to pt 0
			ofCurveVertex(curveVertices[0].x, curveVertices[0].y);	// we duplicate the first point twice
		} else {
			ofCurveVertex(curveVertices[i].x, curveVertices[i].y);
		}
	}
	
	ofEndShape();
	
	
	// show a faint the non-curve version of the same polygon:
	ofEnableAlphaBlending();
	ofNoFill();
	ofSetColor(0,0,0,40);
	ofBeginShape();
	for (int i = 0; i < nCurveVertexes; i++){
		ofVertex(curveVertices[i].x, curveVertices[i].y);
	}
	ofEndShape(true);
	
	
	ofSetColor(0,0,0,80);
	for (int i = 0; i < nCurveVertexes; i++){
		if (curveVertices[i].bOver == true) ofFill();
		else ofNoFill();
		ofCircle(curveVertices[i].x, curveVertices[i].y,4);
	}
	ofDisableAlphaBlending();
	//-------------------------------------

	for(int i=0;i<74;i++) {

		ofDrawBitmapString(ofToString(i,0), dotNum[i].x, dotNum[i].y);
		
	}
	
	
	
	//ofDrawBitmapString("1",(int)ofRandom(80,1000),(int)ofRandom(100,600));
	
/*		ofDrawBitmapString("1",131,419);	
	ofDrawBitmapString("2",329,358);
	ofDrawBitmapString("3",146,392);
	ofDrawBitmapString("4",491,370);
	ofDrawBitmapString("5",161,367);
	ofDrawBitmapString("6",518,377);
	ofDrawBitmapString("7",449,332);
	ofDrawBitmapString("8",494,388);
	ofDrawBitmapString("9",525,392);
	ofDrawBitmapString("10",504,379);
	ofDrawBitmapString("11",618,287);
	ofDrawBitmapString("12",540,376);
	ofDrawBitmapString("13",638,302);
	ofDrawBitmapString("14",632,146);
	ofDrawBitmapString("15",600,293);
	ofDrawBitmapString("16",714,134);
	ofDrawBitmapString("17",534,250);
	ofDrawBitmapString("18",825,148);
	ofDrawBitmapString("19",660,142);
	ofDrawBitmapString("20",848,247);
	ofDrawBitmapString("21",731,127);
	ofDrawBitmapString("22",824,313);
	ofDrawBitmapString("23",806,173);
	ofDrawBitmapString("24",758,313);
	ofDrawBitmapString("25",887,218);
	ofDrawBitmapString("26",734,292);
	ofDrawBitmapString("27",750,238);
	ofDrawBitmapString("28",738,206);
	ofDrawBitmapString("29",704,200);
	ofDrawBitmapString("30",656,232);
	ofDrawBitmapString("31",647,266);
	ofDrawBitmapString("32",699,287);
	ofDrawBitmapString("33",737,260);
	ofDrawBitmapString("34",722,320);
	ofDrawBitmapString("35",675,317);
	ofDrawBitmapString("36",621,350);
	ofDrawBitmapString("37",597,412);
	ofDrawBitmapString("38",795,341);
	ofDrawBitmapString("39",621,388);
	ofDrawBitmapString("40",723,407);
	ofDrawBitmapString("41",809,392);
	ofDrawBitmapString("42",833,410);
	ofDrawBitmapString("43",824,440);
	ofDrawBitmapString("44",768,466);
	ofDrawBitmapString("45",698,463);
	ofDrawBitmapString("46",659,439);
	ofDrawBitmapString("47",660,407);
	ofDrawBitmapString("48",729,343);
	ofDrawBitmapString("49",647,370);
	ofDrawBitmapString("50",867,368);
	ofDrawBitmapString("51",785,319);
	ofDrawBitmapString("52",888,422);
	ofDrawBitmapString("53",849,308);
	ofDrawBitmapString("54",852,490);
	ofDrawBitmapString("55",891,322);
	ofDrawBitmapString("56",813,503);
	ofDrawBitmapString("57",896,394);
	ofDrawBitmapString("58",738,509);
	ofDrawBitmapString("59",899,470);
	ofDrawBitmapString("60",645,490);
	ofDrawBitmapString("61",852,547);
	ofDrawBitmapString("62",644,454);
	ofDrawBitmapString("63",708,536);
	ofDrawBitmapString("64",635,440);
	ofDrawBitmapString("65",518,481);
	ofDrawBitmapString("66",627,470);
	ofDrawBitmapString("67",537,454);
	ofDrawBitmapString("68",136,568);
	ofDrawBitmapString("69",424,506);
	ofDrawBitmapString("70",136,535);
	ofDrawBitmapString("71",272,601);
	ofDrawBitmapString("72",181,521);
	ofDrawBitmapString("73",397,439);
	ofDrawBitmapString("74",131,404);

	
*/
	
	//----------------------
	ofSetColor(0x000000);
	ofDrawBitmapString("use the bezier points (from left to right) to connect the dots", 100,70);
	
	
	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
	for (int i = 0; i < nCurveVertexes; i++){
		float diffx = x - curveVertices[i].x;
		float diffy = y - curveVertices[i].y;
		float dist = sqrt(diffx*diffx + diffy*diffy);
		if (dist < curveVertices[i].radius){
			curveVertices[i].bOver = true;
		} else {
			curveVertices[i].bOver = false;
		}	
	}
	

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
	
	for (int i = 0; i < nCurveVertexes; i++){
		if (curveVertices[i].bBeingDragged == true){
			curveVertices[i].x = x;
			curveVertices[i].y = y;
		}
	}
	

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
	
	for (int i = 0; i < nCurveVertexes; i++){
		float diffx = x - curveVertices[i].x;
		float diffy = y - curveVertices[i].y;
		float dist = sqrt(diffx*diffx + diffy*diffy);
		if (dist < curveVertices[i].radius){
			curveVertices[i].bBeingDragged = true;
		} else {
			curveVertices[i].bBeingDragged = false;
		}	
	}

	
	
	pt.set(x,y);
	
	
	
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
	
	for (int i = 0; i < nCurveVertexes; i++){
		curveVertices[i].bBeingDragged = false;	
	}

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

//